<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class RelatoriosTarefasFactory {

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getFuncionarios() {

        $sql = "SELECT NRFUNCIONARIO, NMFUNCIONARIO
                        FROM FCM_FUNCIONARIO
                       WHERE IDATIVO = 'S'
                    ORDER BY NMFUNCIONARIO";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getRelatoriosTarefas($nrX, $params) {
        $session = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI'";

        $std = $this->connection->prepare($session);
        $std->execute();

        $sql = "SELECT CHKA.NRCHECKLISTAGEND, CHKA.NRLOCALCLIENTE, CHKA.NRCHECKLIST, CHKA.NRFUNCIONARIO, CHKA.IDSITUACAOAGEND, 
                    CHKA.DTHORAAGEND, CHKA.IDATIVO, CHKA.DTHRFINALAGEND, CHKA.NMCHECKLISTAGEND, 
                    FUNC.NMFUNCIONARIO, LC.NMLOCALCLIENTE, CHK.NMCHECKLIST, C.NMRAZSOCCLIE, ROUND(24 *(60 *(CHKA.DTHRFINALAGEND - CHKA.DTHORAAGEND)), 2) AS DURACAO, CHKA.DSJUSTCANCELAMENTO, LC.CDCLIENTE
                         FROM FCM_CHECKLISTAGEND CHKA
                    LEFT JOIN FCM_FUNCIONARIO FUNC 
                           ON FUNC.NRFUNCIONARIO = CHKA.NRFUNCIONARIO
                    LEFT JOIN FCM_LOCALCLI LC
                           ON LC.NRLOCALCLIENTE = CHKA.NRLOCALCLIENTE
                    LEFT JOIN FCM_CHECKLIST CHK
                           ON CHK.NRCHECKLIST = CHKA.NRCHECKLIST
                    LEFT JOIN CLIENTE C 
                           ON C.CDCLIENTE = LC.CDCLIENTE
                    WHERE ((CHKA.NRFUNCIONARIO IN ($nrX))
                          OR (CHKA.CDOPERINCLUSAO = :CDOPERADOR))";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getItensTarefas($parametros) {
        $nrchecklistagend = $parametros;

        $sql = "SELECT TA.NRTAREFAAGEND, TA.NRCHECKLISTAGEND, TA.NRFUNCIONARIO, TA.DSOBSTAREFAAGEND, TA.IDREALIZADO, CA.NMCHECKLISTAGEND, TF.NMTAREFA
                    FROM FCM_TAREFAAGEND TA
                    JOIN FCM_CHECKLISTAGEND CA
                      ON CA.NRCHECKLISTAGEND = TA.NRCHECKLISTAGEND
                    JOIN FCM_TAREFACHK T
                      ON T.NRTAREFACHK = TA.NRTAREFACHK
                    JOIN FCM_TAREFA TF
                      ON T.NRTAREFA = TF.NRTAREFA
                   WHERE TA.NRCHECKLISTAGEND = $nrchecklistagend";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getFotosTarefas($parametros) {
        $nrchecklistagend = $parametros;

        $sql = "SELECT FTA.NRFOTOTAREFAAGEND, FTA.NRTAREFAAGEND, FTA.DSFOTOTAREFAAGEND
                    FROM FCM_FOTOTAREFAAGEND FTA
                    JOIN FCM_TAREFAAGEND TA
                      ON TA.NRTAREFAAGEND = FTA.NRTAREFAAGEND
                    JOIN FCM_CHECKLISTAGEND CHKA
                      ON CHKA.NRCHECKLISTAGEND = TA.NRCHECKLISTAGEND
                   WHERE CHKA.NRCHECKLISTAGEND = $nrchecklistagend";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}